#ifndef CORE_HASH_CODE_H
#define CORE_HASH_CODE_H

#include "utils/Types.h"

namespace Core {
    template<typename H>
    u32 hashCode(const H& key) {
        return key.hashCode();
    }

    /*inline u32 hashCode(int key) {
        static_assert(sizeof(key) == sizeof(u32),
                      "unwanted loose of precision in hash");
        return static_cast<u32>(key);
    }

    inline u32 hashCode(unsigned int key) {
        static_assert(sizeof(key) == sizeof(u32),
                      "unwanted loose of precision in hash");
        return key;
    }*/

    u32 hashCode(char key);
    u32 hashCode(signed char key);
    u32 hashCode(signed short key);
    u32 hashCode(signed int key);
    u32 hashCode(signed long key);
    u32 hashCode(signed long long key);
    u32 hashCode(unsigned char key);
    u32 hashCode(unsigned short key);
    u32 hashCode(unsigned int key);
    u32 hashCode(unsigned long key);
    u32 hashCode(unsigned long long key);
}

#endif